SystemOrganization addCategory: #FuelMetalevel!
SystemOrganization addCategory: 'FuelMetalevel-Clusters'!
SystemOrganization addCategory: 'FuelMetalevel-Mappers'!

FLIteratingCluster subclass: #FLBehaviorCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLBehaviorCluster commentStamp: 'MartinDias 7/30/2011 20:31' prior: 0!
I have the common behavior for serializing class and trait behaviors in full detail.!

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
afterMaterializationStepWith: aDecoder

	objects do:	[ :aClassOrTrait | 
		aClassOrTrait fuelInitializeTraitComposition.
		aClassOrTrait fuelAfterMaterialization ]! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstance: aClassOrTrait with: aDecoder

	self subclassResponsibility! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstancesStepWith: aDecoder

	objects do:	[ :aClassOrTrait | self materializePostInstance: aClassOrTrait with: aDecoder ]! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: aClassOrTrait with: aDecoder

	aClassOrTrait methodDictionary: aDecoder nextEncodedReference.
	aClassOrTrait organization: aDecoder nextEncodedReference.
	aClassOrTrait basicLocalSelectors: aDecoder nextEncodedReference.
	aClassOrTrait traitComposition: aDecoder nextEncodedReference.! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder

	objects do:	[ :aClassOrTrait | self materializeReferencesOf: aClassOrTrait with: aDecoder ]! !

!FLBehaviorCluster methodsFor: 'analyzing' stamp: 'MartinDias 7/30/2011 20:17'!
referencesOf: aClassOrTrait do: aBlock

	aBlock value: aClassOrTrait methodDictionary.
	aBlock value: aClassOrTrait organization.
	aBlock value: aClassOrTrait traitComposition.
	aBlock value: aClassOrTrait basicLocalSelectors.! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializePostInstance: aClassOrTrait with: anEncoder

	self subclassResponsibility! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializePostInstancesStepWith: anEncoder  

	objects do:	[ :aClassOrTrait | self serializePostInstance: aClassOrTrait with: anEncoder ]! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: aClassOrTrait with: anEncoder

	anEncoder encodeReferenceTo: aClassOrTrait methodDictionary.
	anEncoder encodeReferenceTo: aClassOrTrait organization. 
	anEncoder encodeReferenceTo: aClassOrTrait basicLocalSelectors.
	anEncoder encodeReferenceTo: aClassOrTrait traitComposition.! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesStepWith: anEncoder

	objects do:	[ :aClassOrTrait | self serializeReferencesOf: aClassOrTrait with: anEncoder ]! !

FLBehaviorCluster subclass: #FLClassCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLClassCluster commentStamp: 'MartinDias 7/30/2011 20:31' prior: 0!
I am a cluster for storing classes in full detail.!

!FLClassCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:36'!
clusterBucketIn: aClusterization

	^aClusterization metalevelInstanceSideBucket! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	| aMetaclass |
	aMetaclass := aDecoder nextEncodedReference.
	^aMetaclass new! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:56'!
materializePostInstance: aClass with: aDecoder

	| superclass category name instanceVariableNames format |
	superclass := aDecoder nextEncodedReference.
	category := aDecoder nextEncodedReference.
	name := aDecoder nextEncodedReference.
	format := aDecoder nextEncodedReference.
	instanceVariableNames := aDecoder nextEncodedString subStrings: ' '.

	aClass 
		superclass: superclass;
		setFormat: format;
		setName: name;
		basicInstVarNames: instanceVariableNames;
		basicCategory: category; 
		methodDict: MethodDictionary new.
		! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: aClass with: aDecoder

	super materializeReferencesOf: aClass with: aDecoder.

	aClass classPool: aDecoder nextEncodedReference.
	aClass sharedPools: aDecoder nextEncodedReference.
	aClass environment: aDecoder nextEncodedReference.
	aClass basicSubclasses: aDecoder nextEncodedReference.
	
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aClass instVarAt: index put: aDecoder nextEncodedReference ]! !

!FLClassCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 8/2/2012 12:19'!
referencesOf: aClass do: aBlock

	super referencesOf: aClass do: aBlock.

	aBlock value: aClass classSide.
	aBlock value: aClass superclass.
	aBlock value: aClass basicClassPool.
	aBlock value: aClass basicSharedPools. 
	aBlock value: aClass category.
	aBlock value: aClass name.
	aBlock value: aClass format.	
	aBlock value: aClass basicEnvironment.
	aBlock value: aClass basicSubclasses.
	
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aBlock value: (aClass instVarAt: index) ]! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeInstance: aClass with: anEncoder

	anEncoder encodeReferenceTo: aClass classSide! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 8/2/2012 12:17'!
serializePostInstance: aClass with: anEncoder

	anEncoder encodeReferenceTo: aClass superclass.
	"Do not use #basicCategory because since it may be lazily computed it may happen that it is still in nil. "
	anEncoder encodeReferenceTo: aClass category.
	anEncoder encodeReferenceTo: aClass name.
	anEncoder encodeReferenceTo: aClass format.	
	anEncoder encodeString: aClass instanceVariablesString.
	self flag: #todo. "The array of variable names represents a circularity problem between clusters: if we encode the reference to such array, then the cluster for arrays should be before of Class cluster. But this would disable us to serialize an array of internal classes."
! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: aClass with: anEncoder

	super serializeReferencesOf: aClass with: anEncoder.

	anEncoder encodeReferenceTo: aClass basicClassPool. 
	anEncoder encodeReferenceTo: aClass basicSharedPools. 
	anEncoder encodeReferenceTo: aClass basicEnvironment.
	anEncoder encodeReferenceTo: aClass basicSubclasses.
 
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | anEncoder encodeReferenceTo: (aClass instVarAt: index) ]! !

FLBehaviorCluster subclass: #FLClassTraitCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLClassTraitCluster commentStamp: 'MartinDias 7/30/2011 20:30' prior: 0!
I am a cluster for storing class traits in full detail.!

!FLClassTraitCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:37'!
clusterBucketIn: aClusterization

	^aClusterization metalevelClassSideBucket! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^ClassTrait basicNew! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstance: aClassTrait with: aDecoder

	aClassTrait 
		initialize.! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializePostInstance: aClassTrait with: anEncoder
! !

FLBehaviorCluster subclass: #FLMetaclassCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLMetaclassCluster commentStamp: 'MartinDias 7/30/2011 20:30' prior: 0!
I am a cluster for storing metaclasses in full detail.!

!FLMetaclassCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:38'!
clusterBucketIn: aClusterization

	^aClusterization metalevelClassSideBucket! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^Metaclass new! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:58'!
materializePostInstance: aMetaclass with: aDecoder

	| superclass instanceVariableNames format |
	superclass := aDecoder nextEncodedReference.
	instanceVariableNames := aDecoder nextEncodedString subStrings: ' '.
	format := aDecoder nextEncodedUint16.

	aMetaclass
		superclass: superclass 
		methodDictionary: MethodDictionary new 
		format: format;
		basicInstVarNames: instanceVariableNames.! !

!FLMetaclassCluster methodsFor: 'analyzing' stamp: 'MartinDias 7/29/2011 21:12'!
referencesOf: aMetaclass do: aBlock

	super referencesOf: aMetaclass do: aBlock.
	
	aBlock value: aMetaclass superclass.! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:01'!
serializePostInstance: aMetaclass with: anEncoder

	anEncoder encodeReferenceTo: aMetaclass superclass.
	anEncoder encodeString: aMetaclass instanceVariablesString.
	anEncoder encodeUint16: aMetaclass format.
	! !

FLBehaviorCluster subclass: #FLTraitCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLTraitCluster commentStamp: 'MartinDias 7/30/2011 20:30' prior: 0!
I am a cluster for storing traits in full detail.!

!FLTraitCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:39'!
clusterBucketIn: aClusterization

	^aClusterization metalevelInstanceSideBucket! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^Trait basicNew! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/2/2014 18:15'!
materializePostInstance: aTrait with: aDecoder

	| classTrait category name environment |
	classTrait := aDecoder nextEncodedReference.
	category := aDecoder nextEncodedReference.
	name := aDecoder nextEncodedReference.
	environment := aDecoder nextEncodedReference.
	
	aTrait 
		initialize;
		name: name;
		basicCategory: (category ifNil: [ #'_UnpackagedPackage' ]) asSymbol;
		classTrait: classTrait;
		environment: environment.
	
	classTrait baseTrait: aTrait.! !

!FLTraitCluster methodsFor: 'analyzing' stamp: 'MarianoMartinezPeck 8/2/2012 12:18'!
referencesOf: aTrait do: aBlock

	super referencesOf: aTrait do: aBlock.

	aBlock value: aTrait classSide.
	aBlock value: aTrait basicEnvironment.
	aBlock value: aTrait category.
	aBlock value: aTrait name.
! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 8/2/2012 12:17'!
serializePostInstance: aTrait with: anEncoder

	anEncoder encodeReferenceTo: aTrait classSide.
		"Do not use #basicCategory because since it may be lazily computed it may happen that it is still in nil. "
	anEncoder encodeReferenceTo: aTrait category.
	anEncoder encodeReferenceTo: aTrait name.
	anEncoder encodeReferenceTo: aTrait basicEnvironment.
! !

FLIteratingCluster subclass: #FLGlobalClassPoolAssociationCluster
	instanceVariableNames: 'classOwnerByAssociation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLGlobalClassPoolAssociationCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for class variable associations, i.e. bindings that belong to the class pool of a Class included on Smalltalk globals.!

!FLGlobalClassPoolAssociationCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:37'!
clusterBucketIn: aClusterization

	^aClusterization baselevelBucket! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'accessing' stamp: 'MartinDias 9/4/2011 23:57'!
classOwnerByAssociation
	^ classOwnerByAssociation! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'accessing' stamp: 'MartinDias 9/4/2011 23:57'!
classOwnerByAssociation: anObject
	classOwnerByAssociation := anObject! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'initialize-release' stamp: 'MartinDias 3/16/2012 22:59'!
declare: anAssociation belongsTo: ownerClass

	classOwnerByAssociation at: anAssociation put: ownerClass! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/8/2012 13:23'!
initializeAnalyzing

	super initializeAnalyzing.
	classOwnerByAssociation := IdentityDictionary new.! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	| keyName ownerClass |
	ownerClass := aDecoder nextEncodedReference.
	keyName := aDecoder nextEncodedReference.
	^ownerClass classPool associationAt: keyName! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'analyzing' stamp: 'MartinDias 9/4/2011 23:56'!
referencesOf: anAssociation do: aBlock

	aBlock 
		value: (classOwnerByAssociation at: anAssociation);
		value: anAssociation key! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'resetting' stamp: 'MarianoMartinezPeck 7/30/2012 21:33'!
reinitialize
	super initializeAnalyzing! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeInstance: anAssociation with: anEncoder

	anEncoder 
		encodeReferenceTo: (classOwnerByAssociation at: anAssociation);
		encodeReferenceTo: anAssociation key! !

FLMapper subclass: #FLFullGlobalMapper
	instanceVariableNames: 'clusterByObject globalSymbols globalsCluster instanceSideCluster classSideCluster classVariablesCluster globalAssociationCluster globalCompiledMethodCluster internalMethods internalBehaviors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Mappers'!

!FLFullGlobalMapper class methodsFor: 'instance-creation' stamp: 'MartinDias 2/22/2013 12:58'!
newWithInternalBehaviors: internals internalMethods: methods globalSymbols: globalSymbols globalEnvironment: globalEnvironment

	^self basicNew
		initializeWithInternalBehaviors: internals
		internalMethods: methods 
		globalSymbols: globalSymbols
		globalEnvironment: globalEnvironment;
		yourself 
		! !

!FLFullGlobalMapper methodsFor: 'resetting' stamp: 'MarianoMartinezPeck 7/30/2012 22:07'!
addOldInternalBehaviorsToCache

	"Old internals should now be considered as globals. Therefore, we need to cache them."
	(internalBehaviors collect: [:each | each binding ]) do: [:each |  
		each value isBehavior 
			ifTrue: [  self cacheClassAssociation: each].
		each value isTrait
			ifTrue: [ self cacheTraitAssociation: each].
	].
			! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/20/2012 15:54'!
cacheClassAssociation: anAssociation

	clusterByObject
		at: anAssociation put: globalAssociationCluster;
		at: anAssociation value put: instanceSideCluster;
		at: anAssociation value class put: classSideCluster.
	anAssociation value classPool
		associationsDo: [ :aVariableAssociation | 
			classVariablesCluster 
				declare: aVariableAssociation 
				belongsTo: anAssociation value.
			clusterByObject 
				at: aVariableAssociation 
				put: classVariablesCluster ]! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 4/21/2012 18:12'!
cacheGlobalAssociation: anAssociation
	clusterByObject at: anAssociation put: globalAssociationCluster.	
	"Some globals, like ActiveHand have a nil value in the Smalltalk globals. Therefore, we cannot map nil to globalCluster. We could filter before in #defaultGlobalSymbols but that means that not even the Association will be consider global."
	anAssociation value isNil
		ifFalse: [ clusterByObject at: anAssociation value put: globalsCluster ]! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MartinDias 2/22/2013 12:59'!
cacheGlobalsIn: globalEnvironment

	globalEnvironment associationsDo: [:each | 
		(internalBehaviors includes: each value)
			ifFalse: [
				each value isBehavior 
					ifTrue: [ self cacheClassAssociation: each ].
				each value isTrait
					ifTrue: [ self cacheTraitAssociation: each ]].
		(globalSymbols includes: each key) 
			ifTrue: [
				self cacheGlobalAssociation: each ]].! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MartinDias 3/16/2012 23:08'!
cacheTraitAssociation: anAssociation

	clusterByObject
		at: anAssociation put: globalAssociationCluster;
		at: anAssociation value put: instanceSideCluster;
		at: anAssociation value classSide put: classSideCluster.! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MartinDias 2/22/2013 12:59'!
initializeWithInternalBehaviors: explicitInternals internalMethods: methods globalSymbols: explicitExternals globalEnvironment: globalEnvironment

	self initialize.
	clusterByObject := FLLargeIdentityDictionary new.
	internalBehaviors := explicitInternals.
	internalMethods := methods.
	globalSymbols := explicitExternals.
	globalsCluster := FLGlobalValueCluster newAnalyzing.
	instanceSideCluster := FLGlobalClassCluster newAnalyzing.
	classSideCluster := FLGlobalClassSideCluster newAnalyzing.
	classVariablesCluster := FLGlobalClassPoolAssociationCluster newAnalyzing.
	globalAssociationCluster := FLGlobalAssociationCluster newAnalyzing.
	globalCompiledMethodCluster := FLGlobalCompiledMethodCluster newAnalyzing.
	self cacheGlobalsIn: globalEnvironment.! !

!FLFullGlobalMapper methodsFor: 'mapping' stamp: 'MarianoMartinezPeck 5/11/2012 10:57'!
mapAndTrace: anObject

	| aGlobalCluster |
	aGlobalCluster := 
		clusterByObject 
			at: anObject 
			ifAbsent: [ 
				"This is a hack to support correct behavior of globals for methods. This is just to avoid adding all 
				methods to the cache"
				(anObject class == CompiledMethod and: [self shouldConsdierMethodAsGlobal: anObject])
					ifTrue: [ globalCompiledMethodCluster  ]
					ifFalse: [^ next mapAndTrace: anObject ] 
				].

	(self 
		clusterInstanceOf: aGlobalCluster class
		keyInBucket: aGlobalCluster class name 
		factory: [ aGlobalCluster ])
		add: anObject traceWith: analysis
	! !

!FLFullGlobalMapper methodsFor: 'resetting' stamp: 'MarianoMartinezPeck 7/30/2012 21:51'!
reinitializeGlobalClustersForInternalBehaviors
	"All clusters should be reinitialized because they contain status of the last serialization such as the instVar 'objects' or 'theClass'. Moreoever, in the instVar 'clusterByObject' of the analizer, we have already objects associated with instances of thee clusters. If we create new clusters, we will have different instances of the same cluster. In thise case, we want to use the same cluster instance, hence we reinitialize them'  '"
	globalsCluster initializeAnalyzing.
	instanceSideCluster initializeAnalyzing.
	classSideCluster initializeAnalyzing.
	globalAssociationCluster initializeAnalyzing.
	globalCompiledMethodCluster initializeAnalyzing.
	
	"Most #initialize do the normal initialize of a cluster, which empties 'objects'. However, for the classPool cluster, if we send #initialize we will also be cleaning what we want to cache 'classOwnerByAssociation'. So we send a specific message #reinitialize that do not clean that.  "
	classVariablesCluster reinitialize! !

!FLFullGlobalMapper methodsFor: 'resetting' stamp: 'MarianoMartinezPeck 7/30/2012 21:31'!
removeNewInternalBehaviorsFromCache: explicitInternals

	"New internal behaviors may have been considerd as global previously. Therefore, we need to remove it from everywhere in that case."
	(explicitInternals collect: [:each | each binding ]) do: [:each |  
		each value isBehavior 
			ifTrue: [ 
				clusterByObject removeKey: each ifAbsent: [].
				clusterByObject removeKey: each value ifAbsent: [].
				clusterByObject removeKey: each value class ifAbsent: [].
				each value classPool associationsDo: [ :aVariableAssociation | 
					clusterByObject removeKey: aVariableAssociation ifAbsent: [].
					classVariablesCluster classOwnerByAssociation removeKey: aVariableAssociation ifAbsent:[].
					 ].
				].
		each value isTrait
			ifTrue: [ 
				clusterByObject removeKey: each ifAbsent: [].
				clusterByObject removeKey: each value ifAbsent: [].
				clusterByObject removeKey: each value classSide ifAbsent: [].]
	].
! !

!FLFullGlobalMapper methodsFor: 'resetting' stamp: 'MarianoMartinezPeck 7/30/2012 21:51'!
resetForInternalBehaviors: explicitInternals internalMethods: methods

	self reinitializeGlobalClustersForInternalBehaviors.
	self removeNewInternalBehaviorsFromCache: explicitInternals.
	self addOldInternalBehaviorsToCache.

	"Now that old internal behaviors have been updated, we can set the new ones"
	internalBehaviors := explicitInternals.
	
	"The methods are not cached anywhere, so we can just set the new ones"
	internalMethods := methods.
		
	"For the moment we set the default symbols. In the future we can pass them by parameter also "
	globalSymbols := FLAnalyzer defaultGlobalSymbols.
! !

!FLFullGlobalMapper methodsFor: 'mapping' stamp: 'MarianoMartinezPeck 5/11/2012 12:23'!
shouldConsdierMethodAsGlobal: aCompiledMethod
	"Answers true when aCompiledMethod must be considered global, and false otherwise.
	Global methods are those which are NOT included in the classes considered as internal, nor in the methods consider as internal, nor if they are DoIts."
	^ ((((internalBehaviors includes: aCompiledMethod methodClass) not
		and: [(internalBehaviors includes: aCompiledMethod methodClass theNonMetaClass) not]) 
			and: [(internalMethods includes: aCompiledMethod) not])
				and: [aCompiledMethod isInstalled ])
					and: [aCompiledMethod isDoIt not]! !

FLGlobalCluster subclass: #FLGlobalAssociationCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLGlobalAssociationCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
could be serialized and materialized by me.!

!FLGlobalAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:29'!
materializeInstanceWith: aDecoder

	^self materializeGlobalAssociationFrom: aDecoder! !

!FLGlobalAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/30/2011 12:27'!
serializeInstance: anAssociation with: anEncoder
	
	self serializeGlobalAssociationKeyed: anAssociation key on: anEncoder ! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:53'!
considerInternalAllBehaviors: classes

	internalClasses addAll: classes.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:43'!
considerInternalAllMethods: methods

	internalMethods addAll: methods.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:54'!
considerInternalBehavior: class

	internalClasses add: class.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:46'!
considerInternalMethod: aMethod

	internalMethods add: aMethod.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel' stamp: 'MartinDias 2/22/2013 12:58'!
fullGlobalMappers

	^ Array with: (
		FLFullGlobalMapper 
			newWithInternalBehaviors: internalClasses 
			internalMethods: internalMethods 
			globalSymbols: globalSymbols
			globalEnvironment: globalEnvironment).
	! !

!FLAnalyzer methodsFor: '*FuelMetalevel' stamp: 'MarianoMartinezPeck 8/1/2012 11:19'!
reusableFullGlobalMappers

	globalMappers isNil ifTrue: [ globalMappers := Array with: (FLFullGlobalMapper newWithInternalBehaviors: internalClasses internalMethods: internalMethods globalSymbols: globalSymbols) ].
	^ globalMappers ! !

!FLAnalyzer methodsFor: '*FuelMetalevel-resetting' stamp: 'MarianoMartinezPeck 7/30/2012 22:36'!
reuseFullGlobalMappers: aFullGlobalMappers withInternalBehaviors: internals internalMethods: methods

	aFullGlobalMappers do: [:each | each resetForInternalBehaviors: internals internalMethods: methods]. 
	internalClasses := internals.
	internalMethods := methods.
	globalMappers := aFullGlobalMappers.
	! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MartinDias 12/31/2011 00:13'!
useFullMappers

	globalMappersFactory := [self fullGlobalMappers].
	generalMapperFactory := [FLFullGeneralMapper new].! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 8/1/2012 11:19'!
useReusableFullMappers

	globalMappersFactory := [self reusableFullGlobalMappers].
	generalMapperFactory := [FLFullGeneralMapper new].! !

!Dictionary methodsFor: '*FuelMetalevel' stamp: 'MarianoMartinezPeck 12/12/2011 16:35'!
identityIncludesAssociation: anAssociation
	^ (self   
	      associationAt: anAssociation key
	      ifAbsent: [ ^ false ]) == anAssociation
! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/30/2011 18:23'!
basicClassPool
	"Answer nil or the dictionary of class variables."

	^classPool! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MarianoMartinezPeck 6/29/2011 11:04'!
basicEnvironment

	^ environment! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/30/2011 18:23'!
basicSharedPools
	"Answer nil or a Set of the pool dictionaries declared in the receiver."

	^sharedPools! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 5/14/2011 21:44'!
basicSubclasses

	^ subclasses! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 5/14/2011 21:45'!
basicSubclasses: anArray

	subclasses := anArray! !

FLLightGeneralMapper subclass: #FLFullGeneralMapper
	instanceVariableNames: 'classCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Mappers'!

!FLFullGeneralMapper commentStamp: 'MartinDias 8/7/2011 12:24' prior: 0!
I know how to map an object to its default cluster. I can map every object.!

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:33'!
visitClass: aClass

	self mapAndTraceByClusterName: aClass to: FLClassCluster! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:33'!
visitClassTrait: aClassTrait
	
	self mapAndTraceByClusterName: aClassTrait to: FLClassTraitCluster! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MarianoMartinezPeck 5/11/2012 12:01'!
visitCompiledMethod: aCompiledMethod
	
	self mapAndTraceByClusterName: aCompiledMethod to: FLCompiledMethodCluster
! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:33'!
visitMetaclass: aMetaclass

	self mapAndTraceByClusterName: aMetaclass to: FLMetaclassCluster! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:34'!
visitTrait: aTrait

	self mapAndTraceByClusterName: aTrait to: FLTraitCluster! !

!TBehavior methodsFor: '*FuelMetalevel' stamp: 'MartinDias 6/4/2014 12:31'!
fuelInitializeTraitComposition

	self traitComposition traits do: [:each | each addUser: self]! !

!Trait methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/1/2011 04:32'!
basicEnvironment

	^self environment ! !

Object subclass: #ManifestFuelMetalevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel'!

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/20/2012 23:51'!
rejectClasses
^ #()! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/20/2012 23:51'!
rejectRules
^ #()! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:20'!
ruleBadMessageRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLClassCluster'' selector: #referencesOf:do: isMetaSide: false)' #'2012-04-21T17:20:38.254000001+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #serializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:20:38.270000001+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #materializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:20:38.289+02:00') )! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:26'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLClassCluster'' selector: #serializePostInstance:with: isMetaSide: false)' #'2012-04-21T17:26:41.049+02:00') )! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:36'!
ruleLawOfDemeterRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLClassCluster'' selector: #referencesOf:do: isMetaSide: false)' #'2012-04-21T17:36:40.844000001+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #serializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:36:40.865+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #materializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:36:40.881000001+02:00') #('(RGMethodDefinition className: ''FLFullGlobalMapper'' selector: #cacheGlobalAssociation: isMetaSide: false)' #'2012-04-21T17:36:41.591+02:00') )! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 18:12'!
ruleNotEliminationRuleV1TruePositive
^ #(#('(RGMethodDefinition className: ''FLFullGlobalMapper'' selector: #cacheGlobalAssociation: isMetaSide: false)' #'2012-04-21T18:12:47.675000001+02:00') )! !

!ClassDescription methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/30/2011 19:23'!
basicInstVarNames: anArray

	instanceVariables := anArray! !

!FLSerializer class methodsFor: '*FuelMetalevel' stamp: 'mariano 5/18/2012 18:50'!
newFull
	| serializer |
	serializer := self new. 
	serializer analyzer useFullMappers.
	^ serializer! !
